#ifndef GRAPHICSH
#define GRAPHICSH

#include <d3dx9.h>
#include <string>
using namespace std;

#ifndef SAFE_DELETE
#define SAFE_DELETE(p) { if(p) { delete (p); (p)=NULL; } }
#endif
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p); (p)=NULL; } }
#endif
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p) { if(p) { (p)->Release(); (p)=NULL; } }
#endif


//==============================================================
// OtBbNX`@\ǗNX
class CGraphics {
protected:

	// Direct3DC^tF[XAfoCX
	LPDIRECT3D9 D3D;
	LPDIRECT3DDEVICE9 Device;

	// EBhEnh
	HWND HWnd;
	
	// ̃EBhEX^C
	DWORD WindowStyle;

	// A
	int Width, Height;

	// tXN[[hȂtrue
	bool FullScreen;

	// tbV[g(Hz)
	int RefreshRate;

	// GDIɂ`悪\ȃT[tFXǂ
	bool IsGDISurface;

	D3DFORMAT DepthStencilFormat;

public:

	// RXgN^CfXgN^
	CGraphics(HWND hwnd);
	~CGraphics();

	// foCX̃Zbg
	void SetWidth(int w) { Width=w; }
	void SetHeight(int h) { Height=h; }
	void SetFullScreen(bool b) { FullScreen=b; }
	void SetRefreshRate(int r) { RefreshRate=r; }
	void SetDepthStencilFormat(D3DFORMAT format) { DepthStencilFormat=format; }
	bool ResetDevice();
	bool DeviceNotReset();

	// V[`̊JnCI
	bool BeginScene() { return SUCCEEDED(Device->BeginScene()); }
	void EndScene() { Device->EndScene(); }

	// ʏCʃtbv
	void Clear(D3DCOLOR color=D3DCOLOR_ARGB(255, 0, 0, 0));
	bool Present();

	// e̎擾
	LPDIRECT3DDEVICE9 GetDevice() { return Device; }
	HWND GetHWnd() { return HWnd; }
	int GetWidth() { return Width; }
	int GetHeight() { return Height; }
	bool IsFullScreen() { return FullScreen; }
	int GetRefreshRate() { return RefreshRate; }

	// GDIɂ`悪\ȃT[tFXɂ
	void PresentGDISurface() { if (!IsGDISurface) Present(); }

	// Cg̐ݒ
	void SetLight(
		int id, D3DLIGHTTYPE type, 
		D3DXVECTOR3 pos, D3DXVECTOR3 dir, D3DXCOLOR color, 
		float range
	);
	void SetLight(
		int id, D3DLIGHTTYPE type, 
		float x, float y, float z,
		float range=1000
	);

	// At@Z[h̎w
	void SetAddAlpha(bool add_alpha);

	// GtFNg̃[h
	ID3DXEffect* LoadEffect(wstring file);
	
	// eNX`̃[h
	LPDIRECT3DTEXTURE9 LoadTexture(wstring file);
};


#endif



