#include "LibUtil.h"


//==============================================================
// Winsock̏ƏI

// gp̃\Pbg
static int SocketCount=0;

// Winsock̏
static void InitializeWinsock() {
	if (SocketCount==0) {
		WSADATA data;
		WSAStartup(MAKEWORD(2,0), &data);
	}
	SocketCount++;
}

// Winsock̏I
static void FinalizeWinsock() {
	SocketCount--;
	if (SocketCount==0) {
		WSACleanup();
	}
}


//==============================================================
// \Pbg{@\

// RXgN^
CTCPBaseSocket::CTCPBaseSocket(SOCKET s)
:	Socket(s)
{
	InitializeWinsock();
	if (Socket==INVALID_SOCKET) {
		Socket=socket(AF_INET, SOCK_STREAM, 0);
	}
}

// fXgN^
CTCPBaseSocket::~CTCPBaseSocket() {
	closesocket(Socket);
	FinalizeWinsock();
}


//==============================================================
// TCP\Pbg

// RXgN^
CTCPSocket::CTCPSocket(SOCKET s)
:	CTCPBaseSocket(s)
{
	LineSeparator.push_back(L"\r\n");
	LineSeparator.push_back(L"\r");
	LineSeparator.push_back(L"\n");
}

// ڑF
// trueԂ
bool CTCPSocket::Connect(wstring host, int port) {

	// zXgAhXɕϊ
	LPHOSTENT hostent=gethostbyname(WideToMulti(host, SJIS).c_str());
	if (!hostent ||
		hostent->h_addrtype!=AF_INET ||
		hostent->h_length!=4 ||
		!hostent->h_addr_list[0]) return false;

	// AhXƃ|[g̓o^
	sockaddr_in sa;
	ZeroMemory(&sa, sizeof(sa));
	sa.sin_family=AF_INET;
	sa.sin_addr.s_addr=*(unsigned long*)(hostent->h_addr_list[0]);
	sa.sin_port=htons(port);

	// ڑ̎s
	return connect(Socket, (sockaddr*)&sa, sizeof(sa))==0;
}

// obt@̑M
int CTCPSocket::Send(const char* buffer, int length) {
	return send(Socket, buffer, length, 0);
}

// obt@̎M
int CTCPSocket::Recv(char* buffer, int length) {
	return recv(Socket, buffer, length, 0);
}

// sZp[^̐ݒ
void CTCPSocket::SetLineSeparator(vector<wstring> ls) {
	LineSeparator.clear();
	for (size_t i=0, n=ls.size(); i<n; i++) {
		LineSeparator.push_back(ls[i]);
	}
}

// s̑M
void CTCPSocket::SendLine(wstring s) {
	if (!LineSeparator.empty()) s+=LineSeparator[0];
	Send(WideToMulti(s, SJIS).c_str(), s.length());
}

// s̎M
wstring CTCPSocket::RecvLine() {
	char buffer[1000];
	int length=0;
	do {
		buffer[length]='\0';
		LineBuffer+=MultiToWide(buffer, SJIS);
		for (size_t i=0, n=LineSeparator.size(); i<n; i++) {
			int pos;
			if ((pos=Find(LineBuffer, LineSeparator[i]))>=0) {
				wstring s=LineBuffer.substr(0, pos);
				LineBuffer=LineBuffer.substr(pos+LineSeparator[i].length());
				return s;
			}
		}
	} while ((length=Recv(buffer, sizeof(buffer)-1))>0);
	return L"";
}


//==============================================================
// TCPT[o\Pbg

// RXgN^
CTCPServerSocket::CTCPServerSocket()
:	CTCPBaseSocket(INVALID_SOCKET)
{}

// |[gԍ̐ݒF
// trueԂ
bool CTCPServerSocket::Bind(int port) {
	sockaddr_in sa;
	ZeroMemory(&sa, sizeof(sa));
	sa.sin_family=AF_INET;
	sa.sin_port=htons(port);
	return bind(Socket, (sockaddr*)&sa, sizeof(sa))==0;
}

// ڑ̎󂯓F
// ɐڑłƂɂCTCPSocket̐VCX^XԂ
CTCPSocket* CTCPServerSocket::Accept() {

	// ڑ҂
	if (listen(Socket, SOMAXCONN)!=0) return NULL;

	// ڑ̎󂯓
	SOCKET socket=accept(Socket, NULL, NULL);
	if (socket==INVALID_SOCKET) return NULL;

	// CTCPSocket̐
	return new CTCPSocket(socket);
}


